package org.jeecg.modules.database.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.database.entity.ExperimentReview;
import org.jeecg.modules.database.service.IExperimentReviewService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import java.util.Arrays;

/**
 * @Description: 试验评定
 * @Author: jeecg-boot
 * @Date: 2024-11-05
 * @Version: V1.0
 */
@Tag(name = "试验评定")
@RestController
@RequestMapping("/database/experimentReview")
@Slf4j
public class ExperimentReviewController extends JeecgController<ExperimentReview, IExperimentReviewService> {
    @Autowired
    private IExperimentReviewService experimentReviewService;

    /**
     * 分页列表查询
     *
     * @param experimentReview
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    //@AutoLog(value = "试验评定-分页列表查询")
    @Operation(summary = "试验评定-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<ExperimentReview>> queryPageList(ExperimentReview experimentReview,
                                                         @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                         @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                         HttpServletRequest req) {
        QueryWrapper<ExperimentReview> queryWrapper = QueryGenerator.initQueryWrapper(experimentReview, req.getParameterMap());
        Page<ExperimentReview> page = new Page<ExperimentReview>(pageNo, pageSize);
        IPage<ExperimentReview> pageList = experimentReviewService.page(page, queryWrapper);
        return Result.OK(pageList);
    }

    /**
     * 添加
     *
     * @param experimentReview
     * @return
     */
    @AutoLog(value = "试验评定-添加")
    @Operation(summary = "试验评定-添加")
    @RequiresPermissions("database:experiment_review:add")
    @PostMapping(value = "/add")
    public Result<String> add(@RequestBody ExperimentReview experimentReview) {
        experimentReviewService.save(experimentReview);
        return Result.OK("添加成功！");
    }

    @Operation(summary = "试验评定-暂存")
    @PostMapping(value = "/temporarySave")
    public Result<String> temporarySave(@RequestBody ExperimentReview experimentReview) {
        experimentReviewService.saveOrUpdate(experimentReview);
        return Result.OK("暂存成功！");
    }


    /**
     * 编辑
     *
     * @param experimentReview
     * @return
     */
    @AutoLog(value = "试验评定-编辑")
    @Operation(summary = "试验评定-编辑")
    @RequiresPermissions("database:experiment_review:edit")
    @RequestMapping(value = "/edit", method = {RequestMethod.PUT, RequestMethod.POST})
    public Result<String> edit(@RequestBody ExperimentReview experimentReview) {
        experimentReviewService.updateById(experimentReview);
        return Result.OK("编辑成功!");
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "试验评定-通过id删除")
    @Operation(summary = "试验评定-通过id删除")
    @RequiresPermissions("database:experiment_review:delete")
    @DeleteMapping(value = "/delete")
    public Result<String> delete(@RequestParam(name = "id", required = true) String id) {
        experimentReviewService.removeById(id);
        return Result.OK("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "试验评定-批量删除")
    @Operation(summary = "试验评定-批量删除")
    @RequiresPermissions("database:experiment_review:delete")
    @DeleteMapping(value = "/deleteBatch")
    public Result<String> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        this.experimentReviewService.removeByIds(Arrays.asList(ids.split(",")));
        return Result.OK("批量删除成功!");
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    //@AutoLog(value = "试验评定-通过id查询")
    @Operation(summary = "试验评定-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<ExperimentReview> queryById(@RequestParam(name = "id", required = true) String id) {
        ExperimentReview experimentReview = experimentReviewService.getById(id);
        if (experimentReview == null) {
            return Result.error("未找到对应数据");
        }
        return Result.OK(experimentReview);
    }

    /**
     * 通过实验id查询
     *
     * @param experimentalId
     * @return
     */
    //@AutoLog(value = "试验评定-通过id查询")
    @Operation(summary = "试验评定-通过实验查询")
    @GetMapping(value = "/queryByExperimentId")
    public Result<ExperimentReview> queryByExperimentId(@RequestParam(name = "experimentId", required = true) String experimentalId) {
        LambdaQueryWrapper<ExperimentReview> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(ExperimentReview::getExperimentId, experimentalId);
        ExperimentReview experimentReview = experimentReviewService.getOne(queryWrapper);
        if (experimentReview == null) {
            return Result.OK();
        }
        return Result.OK(experimentReview);
    }

    /**
     * 导出excel
     *
     * @param request
     * @param experimentReview
     */

    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, ExperimentReview experimentReview) {
        return super.exportXls(request, experimentReview, ExperimentReview.class, "试验评定");
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequiresPermissions("database:experiment_review:add")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, ExperimentReview.class);
    }

}
